/*

** random2.d

** Copyright (C) 2003 Helmut Leitner

** Donated to Digital Mars.

** Released under the GNU GPL, see LICENSE.TXT

** and http://www.gnu.org/copyleft/gpl.html

*/



module venus.random2;

import venus.all;



RandomGenerator_Phobos RandomGeneratorDefault;

RandomProducer Random;



static this()

{

    RandomGeneratorDefault=new RandomGenerator_Phobos;

    Random=new RandomProducer;

}



class RandomProducer {



    iRandomGenerator rg;



    this()

    {

        rg=RandomGeneratorDefault;

    }



    this(iRandomGenerator rg)

    {

        this.rg=rg;

    }



    uint RetUint()

    {

        return rg.RetUint();

    }



    int RetInt()

    {

        return (int) rg.RetUint();

    }



    double RetDouble_01()

    {

        return rg.RetUint()/(uint.max+(double)1);

    }



    double RetDouble_11()

    {

        return (RetInt()+0.5)/(-(double)int.min);

    }



    int RetIntCount(int count)

    {

        return RetDouble_01()*count;

    }



    int RetIntRange(int lo,int hi)

    {

        return lo+RetIntCount(hi-lo+1);

    }



    void CvtRandom() {

        uint seed=(uint)TimerRetCount()&0xFFFFFFFF;

        rg.SetSeed(seed);

    }



    void SetSeed(uint seed)

    {

        rg.SetSeed(seed);

    }



    bit state=0;

    double v2;

    double fact;



    double RetDouble_Gauss() /* Box-Mueller */

    {

        double r;

        double v1;



        if(state)

        {

            state=0;

            return v2*fact;

        }

        do

        {

            v1=RetDouble_11();

            v2=RetDouble_11();

            r=v1*v1+v2*v2;

        } while(r>=1.0 || r==0.0);

        fact=sqrt(-2.0*log(r)/r);



        state=1;

        return v1*fact;

    }



}

